From eda01880ac7667e8bae76e5d9767a81f36ef9399 Mon Sep 17 00:00:00 2001
From: Andres Freund <andres@anarazel.de>
Date: Wed, 2 Mar 2022 18:02:03 -0800
Subject: [PATCH v65 08/11] pgstat: store statistics in shared memory.

TODO:
- verify all AFIXMEs
- Tests for stats dropping:
  - write regression test verifying that BEGIN;CREATE;USE;DROP; doesn't
    leave stats behind (for functions, tables).
  - same, but with different subtransaction cases
  - write tap test checking stats being dropped on replicas
  - think about / document checkpointer race conditions
  - check what needs to be done for index (and matview, ...?) stats
- consistent naming around replacing "stats collector"
  references. Don't like "activity statistics".
- Document stats_fetch_consistency / adjust existing documentation
  around stats fetching

Previously activity statistics is collected via sockets and shared
among backends through files periodically. Such files reaches tens of
megabytes and are created at most every 1 second and such large data
is serialized by stats collector then de-serialized on every backend
periodically. To evade that large cost, this patch places activity
statistics data on shared memory. Each backend accumulates statistics
numbers locally then tries to move them onto the shared statistics at
every transaction end but with intervals not shorter than 10 seconds.
Until 60 second has elapsed since the last flushing to shared stats,
lock failure postpones stats flushing to try to alleviate lock
contention that slows down transactions.  Finally stats flush waits
for locks so that shared statistics doesn't get stale.

Author: Kyotaro Horiguchi <horikyota.ntt@gmail.com>
Author: Andres Freund <andres@anarazel.de>
---
 src/include/access/xact.h                     |   37 +-
 src/include/catalog/pg_proc.dat               |    5 +
 src/include/miscadmin.h                       |    2 +-
 src/include/pgstat.h                          |  725 +--
 src/include/storage/lwlock.h                  |    1 +
 src/include/utils/pgstat_internal.h           |  456 +-
 src/include/utils/timeout.h                   |    1 +
 src/include/utils/wait_event.h                |    2 +-
 src/backend/access/heap/heapam_handler.c      |    4 +-
 src/backend/access/heap/vacuumlazy.c          |    2 +-
 src/backend/access/rmgrdesc/xactdesc.c        |   52 +
 src/backend/access/transam/twophase.c         |   53 +
 src/backend/access/transam/xact.c             |   62 +-
 src/backend/access/transam/xlog.c             |   26 +-
 src/backend/catalog/heap.c                    |    7 +
 src/backend/catalog/pg_proc.c                 |    5 +
 src/backend/commands/dbcommands.c             |    2 +-
 src/backend/commands/functioncmds.c           |    2 +
 src/backend/commands/matview.c                |    8 +-
 src/backend/commands/vacuum.c                 |    4 +-
 src/backend/commands/vacuumparallel.c         |    2 +
 src/backend/postmaster/autovacuum.c           |   70 +-
 src/backend/postmaster/bgwriter.c             |    4 +-
 src/backend/postmaster/checkpointer.c         |   36 +-
 src/backend/postmaster/pgarch.c               |   12 +-
 src/backend/postmaster/pgstat.c               | 5794 ++++++-----------
 src/backend/postmaster/postmaster.c           |   89 +-
 src/backend/postmaster/walwriter.c            |    6 +-
 src/backend/replication/basebackup.c          |    4 +-
 src/backend/replication/logical/logical.c     |    3 +-
 src/backend/replication/slot.c                |   25 +-
 src/backend/storage/buffer/bufmgr.c           |    8 +-
 src/backend/storage/ipc/ipci.c                |    2 +
 src/backend/storage/lmgr/lwlock.c             |    4 +-
 src/backend/storage/lmgr/lwlocknames.txt      |    1 +
 src/backend/storage/smgr/smgr.c               |    5 -
 src/backend/tcop/postgres.c                   |   41 +-
 src/backend/utils/activity/pgstat_database.c  |  338 +-
 src/backend/utils/activity/pgstat_function.c  |  179 +-
 src/backend/utils/activity/pgstat_global.c    |  812 ++-
 src/backend/utils/activity/pgstat_relation.c  |  683 +-
 .../utils/activity/pgstat_subscription.c      |  113 +-
 src/backend/utils/activity/wait_event.c       |    4 +-
 src/backend/utils/adt/pgstatfuncs.c           |   26 +-
 src/backend/utils/cache/relcache.c            |    4 +
 src/backend/utils/init/globals.c              |    1 +
 src/backend/utils/init/miscinit.c             |    3 -
 src/backend/utils/init/postinit.c             |   12 +
 src/backend/utils/misc/guc.c                  |   20 +
 src/backend/utils/misc/postgresql.conf.sample |    3 +-
 src/bin/pg_basebackup/t/010_pg_basebackup.pl  |    2 +-
 doc/src/sgml/monitoring.sgml                  |    3 +-
 src/test/regress/expected/stats.out           |    8 +
 src/test/regress/sql/stats.sql                |   10 +
 src/tools/pgindent/typedefs.list              |   51 +-
 55 files changed, 4317 insertions(+), 5517 deletions(-)

diff --git a/src/include/access/xact.h b/src/include/access/xact.h
index 062cc7e17d8..a1b15918738 100644
--- a/src/include/access/xact.h
+++ b/src/include/access/xact.h
@@ -180,6 +180,7 @@ typedef struct SavedTransactionCharacteristics
 #define XACT_XINFO_HAS_ORIGIN			(1U << 5)
 #define XACT_XINFO_HAS_AE_LOCKS			(1U << 6)
 #define XACT_XINFO_HAS_GID				(1U << 7)
+#define XACT_XINFO_HAS_DROPPED_STATS	(1U << 8)
 
 /*
  * Also stored in xinfo, these indicating a variety of additional actions that
@@ -230,7 +231,7 @@ typedef struct xl_xact_assignment
 typedef struct xl_xact_xinfo
 {
 	/*
-	 * Even though we right now only require 1 byte of space in xinfo we use
+	 * Even though we right now only require two bytes of space in xinfo we use
 	 * four so following records don't have to care about alignment. Commit
 	 * records can be large, so copying large portions isn't attractive.
 	 */
@@ -257,6 +258,24 @@ typedef struct xl_xact_relfilenodes
 } xl_xact_relfilenodes;
 #define MinSizeOfXactRelfilenodes offsetof(xl_xact_relfilenodes, xnodes)
 
+/* FIXME: circular dependency issues */
+/*
+ * A transactionally dropped statistics entry.
+ */
+typedef struct PgStat_DroppedStatsItem
+{
+	int			kind;
+	Oid			dboid;
+	Oid			objoid;
+} PgStat_DroppedStatsItem;
+
+typedef struct xl_xact_dropped_stats
+{
+	int		ndropped;
+	PgStat_DroppedStatsItem dropped_stats[FLEXIBLE_ARRAY_MEMBER];
+} xl_xact_dropped_stats;
+#define MinSizeOfXactDroppedStats offsetof(xl_xact_dropped_stats, dropped_stats)
+
 typedef struct xl_xact_invals
 {
 	int			nmsgs;			/* number of shared inval msgs */
@@ -283,6 +302,7 @@ typedef struct xl_xact_commit
 	/* xl_xact_dbinfo follows if XINFO_HAS_DBINFO */
 	/* xl_xact_subxacts follows if XINFO_HAS_SUBXACT */
 	/* xl_xact_relfilenodes follows if XINFO_HAS_RELFILENODES */
+	/* xl_xact_dropped_stats follows if XINFO_HAS_DROPPED_STATS */
 	/* xl_xact_invals follows if XINFO_HAS_INVALS */
 	/* xl_xact_twophase follows if XINFO_HAS_TWOPHASE */
 	/* twophase_gid follows if XINFO_HAS_GID. As a null-terminated string. */
@@ -298,6 +318,7 @@ typedef struct xl_xact_abort
 	/* xl_xact_dbinfo follows if XINFO_HAS_DBINFO */
 	/* xl_xact_subxacts follows if XINFO_HAS_SUBXACT */
 	/* xl_xact_relfilenodes follows if XINFO_HAS_RELFILENODES */
+	/* xl_xact_dropped_stats follows if XINFO_HAS_DROPPED_STATS */
 	/* No invalidation messages needed. */
 	/* xl_xact_twophase follows if XINFO_HAS_TWOPHASE */
 	/* twophase_gid follows if XINFO_HAS_GID. As a null-terminated string. */
@@ -316,6 +337,8 @@ typedef struct xl_xact_prepare
 	int32		nsubxacts;		/* number of following subxact XIDs */
 	int32		ncommitrels;	/* number of delete-on-commit rels */
 	int32		nabortrels;		/* number of delete-on-abort rels */
+	int32		ncommitdroppedstats;  /* number of stats to drop on commit */
+	int32		nabortdroppedstats;  /* number of stats to drop on abort */
 	int32		ninvalmsgs;		/* number of cache invalidation messages */
 	bool		initfileinval;	/* does relcache init file need invalidation? */
 	uint16		gidlen;			/* length of the GID - GID follows the header */
@@ -342,6 +365,9 @@ typedef struct xl_xact_parsed_commit
 	int			nrels;
 	RelFileNode *xnodes;
 
+	int			ndroppedstats;
+	PgStat_DroppedStatsItem *droppedstats;
+
 	int			nmsgs;
 	SharedInvalidationMessage *msgs;
 
@@ -349,6 +375,8 @@ typedef struct xl_xact_parsed_commit
 	char		twophase_gid[GIDSIZE];	/* only for 2PC */
 	int			nabortrels;		/* only for 2PC */
 	RelFileNode *abortnodes;	/* only for 2PC */
+	int			nabortdroppedstats;		/* only for 2PC */
+	PgStat_DroppedStatsItem *abortdroppedstats; /* only for 2PC */
 
 	XLogRecPtr	origin_lsn;
 	TimestampTz origin_timestamp;
@@ -370,6 +398,9 @@ typedef struct xl_xact_parsed_abort
 	int			nrels;
 	RelFileNode *xnodes;
 
+	int			ndroppedstats;
+	PgStat_DroppedStatsItem *droppedstats;
+
 	TransactionId twophase_xid; /* only for 2PC */
 	char		twophase_gid[GIDSIZE];	/* only for 2PC */
 
@@ -449,6 +480,8 @@ extern int	xactGetCommittedChildren(TransactionId **ptr);
 extern XLogRecPtr XactLogCommitRecord(TimestampTz commit_time,
 									  int nsubxacts, TransactionId *subxacts,
 									  int nrels, RelFileNode *rels,
+									  int ndroppedstats,
+									  PgStat_DroppedStatsItem *droppedstats,
 									  int nmsgs, SharedInvalidationMessage *msgs,
 									  bool relcacheInval,
 									  int xactflags,
@@ -458,6 +491,8 @@ extern XLogRecPtr XactLogCommitRecord(TimestampTz commit_time,
 extern XLogRecPtr XactLogAbortRecord(TimestampTz abort_time,
 									 int nsubxacts, TransactionId *subxacts,
 									 int nrels, RelFileNode *rels,
+									 int ndroppedstats,
+									 PgStat_DroppedStatsItem *droppedstats,
 									 int xactflags, TransactionId twophase_xid,
 									 const char *twophase_gid);
 extern void xact_redo(XLogReaderState *record);
diff --git a/src/include/miscadmin.h b/src/include/miscadmin.h
index 0abc3ad5405..1d89b2759d2 100644
--- a/src/include/miscadmin.h
+++ b/src/include/miscadmin.h
@@ -94,6 +94,7 @@ extern PGDLLIMPORT volatile sig_atomic_t IdleInTransactionSessionTimeoutPending;
 extern PGDLLIMPORT volatile sig_atomic_t IdleSessionTimeoutPending;
 extern PGDLLIMPORT volatile sig_atomic_t ProcSignalBarrierPending;
 extern PGDLLIMPORT volatile sig_atomic_t LogMemoryContextPending;
+extern PGDLLIMPORT volatile sig_atomic_t IdleStatsUpdateTimeoutPending;
 
 extern PGDLLIMPORT volatile sig_atomic_t CheckClientConnectionPending;
 extern PGDLLIMPORT volatile sig_atomic_t ClientConnectionLost;
@@ -333,7 +334,6 @@ typedef enum BackendType
 	B_WAL_SENDER,
 	B_WAL_WRITER,
 	B_ARCHIVER,
-	B_STATS_COLLECTOR,
 	B_LOGGER,
 } BackendType;
 
